//
// RGB test program for GBA devkitadv
//

// ^
typedef unsigned char  u8;
typedef unsigned short u16;

// 䃌WX^
#define VRAMTOP        (u16*)0x6000000  // VRAM frame buffer start address
#define register(p)     *((u16*) p)     // I/O register handling macro
#define LCD_CTRL        0x04000000      // LCD control
#define   LCD_BG2EN     0x0400          // Enable BG2
#define   LCD_MODE3     3               // Video mode 3
#define RGB(r, g, b)    (((b) << 10) + ((g) << 5) + (r))

// u[gP[usł悤ɂ邨܂Ȃ
int __gba_multiboot = 0;                // }`u[gw

// CvO
int main(void)
{
    u8 x, y;
    u16* vram = VRAMTOP;                // Use VRAM as a frame buffer

    // ʃ[h̏
    register(LCD_CTRL) = LCD_BG2EN | LCD_MODE3; // Mode3, BG2 \

    // Ԑ΂̃J[p^[`
    for (x=0; x<80; x++) {
        for (y=0; y<160; y++) {
            vram[y*240+x] = RGB(31, 0, 0);      // put Red dot
            vram[y*240+x+80] = RGB(0, 31, 0);   // put Green dot
            vram[y*240+x+160] = RGB(0, 0, 31);  // put Blue dot
        }
    }

    // [v
    while (1) {
        ;
    }
}
